namespace ExBuddy.OrderBotTags
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Linq;
    using System.Runtime.InteropServices;
    using System.Text.RegularExpressions;
    using System.Windows.Media;
	using System.Threading;
	using System.Threading.Tasks;

	using Buddy.Coroutines;
	
    using Clio.Common;
    using Clio.Utilities;
    using Clio.XmlEngine;

    using ff14bot;
	using ff14bot.AClasses;
    using ff14bot.Behavior;
    using ff14bot.Enums;
    using ff14bot.Helpers;
    using ff14bot.Managers;
    using ff14bot.NeoProfiles;
    using ff14bot.RemoteWindows;
    using ff14bot.Settings;

    using TreeSharp;

    using Action = TreeSharp.Action;

    [XmlElement("Fish")]
    public class FishTag : ProfileBehavior
    {
		[Serializable]
        public enum Abilities
        {
            None = -1,

            Sprint = 3,

            Bait = 288,

            Cast = 289,

            Hook = 296,

            Mooch = 297,

            Stealth = 298,

            Quit = 299,

            Release = 300,

            CastLight = 2135,

            Snagging = 4100,

            CollectorsGlove = 4101,

            Patience = 4102,

            PowerfulHookset = 4103,

            Chum = 4104,

            FishEyes = 4105,

            PrecisionHookset = 4179,

            Patience2 = 4106
        }

        [XmlElement("Keepers")]
        public List<Keeper> Keepers { get; set; }

        [XmlElement("Collectables")]
        public List<Collectable> Collectables { get; set; }

        [XmlElement("FishSpots")]
        public IndexedList<FishSpot> FishSpots { get; set; }

        [DefaultValue(0)]
        [XmlAttribute("Mooch")]
        public int MoochLevel { get; set; }

        [DefaultValue("True")]
        [XmlAttribute("MoochCondition")]
        public string MoochCondition { get; set; }

        [DefaultValue(20)]
        [XmlAttribute("MinFish")]
        public int MinimumFishPerSpot { get; set; }

        [DefaultValue(30)]
        [XmlAttribute("MaxFish")]
        public int MaximumFishPerSpot { get; set; }

        [XmlAttribute("Bait")]
        public string Bait { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("Chum")]
        public bool Chum { get; set; }

        [DefaultValue(VirtualKeys.Numpad0)]
        [XmlAttribute("ConfirmKey")]
        public VirtualKeys ConfirmKey { get; set; }

        [DefaultValue(VirtualKeys.Numpad6)]
        [XmlAttribute("MoveCursorRightKey")]
        public VirtualKeys MoveCursorRightKey { get; set; }

        [DefaultValue("True")]
        [XmlAttribute("Condition")]
        public string Condition { get; set; }

        [XmlAttribute("Weather")]
        public string Weather { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("ShuffleFishSpots")]
        public bool Shuffle { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("Sit")]
        public bool Sit { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("Stealth")]
        public bool Stealth { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("Collect")]
        public bool Collect { get; set; }

        [DefaultValue(Abilities.None)]
        [XmlAttribute("Patience")]
        public Abilities Patience { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("Snagging")]
        public bool Snagging { get; set; }

        [DefaultValue(Abilities.PowerfulHookset)]
        [XmlAttribute("Hookset")]
        public Abilities Hookset { get; set; }

        [DefaultValue(false)]
        [XmlAttribute("UseCordial")]
        public bool UseCordial { get; set; }
				
        [DefaultValue(50.0f)]
        [XmlAttribute("UseCordialMinGPPercent")]
        public float UseCordialMinGPPercent 
		{ 
			get
			{
				return useCordialMinGPPercent;
			}
			
			set
			{
				if (value < 0.0f || value > 100.0f)
				{
					useCordialMinGPPercent = 100.0f;
				}
				else
				{
					useCordialMinGPPercent = value;
				}
			}
		}
				
        [XmlAttribute("Food")]
		public String Food { get; set;}
						
        [XmlAttribute("CollectabilityValue")]
        public int UCollectabilityValue { get; set; }

        public uint CollectabilityValue
        {
            get
            {
                return Convert.ToUInt32(UCollectabilityValue);
            }
        }
		
        protected static Regex FishRegex = new Regex(
            @"You land an{0,1} (.+) measuring (\d{1,4}\.\d) ilms!",
            RegexOptions.Compiled | RegexOptions.IgnoreCase);

        protected static Regex BaitRegex = new Regex(
            @"You apply an{0,1} (.+) to your line.",
            RegexOptions.Compiled | RegexOptions.IgnoreCase);

        private const uint WM_KEYDOWN = 0x100;

        private const uint WM_KEYUP = 0x0101;

        private FishResult fishResult = new FishResult();

        private BotEvent cleanup;

        private string currentBait;

        private int baitCount;

        private int baitAttempts;

        private bool checkRelease;

        private bool isSitting;

        private bool isDone;

        private bool isFishIdentified;

        private int mooch;

        private int fishcount;

        private int amissfish;

        private int fishlimit;

        private bool spotinit;
				
		private bool closeBait;
		
		private bool baitApplied;
		
		private bool awaitBaitApplied;
		
		private bool timedOutOnFirstBaitApplied;
		
		private BagSlot cordialItem;
		
		private float useCordialMinGPPercent;

		private BagSlot foodItem;
		
		private bool initializeFishing;
		
		private bool isMoving;
		
        [return: MarshalAs(UnmanagedType.Bool)]
        [DllImport("user32.dll")]
        protected static extern bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        public Version Version
        {
            get
            {
                return new Version(3, 0, 5);
            }
        }
		
        protected bool HasPatience
        {
            get
            {
                // Gathering Fortune Up (Fishing)
                return Core.Player.HasAura(850);
            }
        }

        protected bool HasSnagging
        {
            get
            {
                // Snagging
                return Core.Player.HasAura(761);
            }
        }

        protected bool HasCollectorsGlove
        {
            get
            {
                // Collector's Glove
                return Core.Player.HasAura(805);
            }
        }

        protected bool HasChum
        {
            get
            {
                // Chum
                return Core.Player.HasAura(763);
            }
        }
		
		protected bool HasFood
		{
			get
			{
				return Core.Player.HasAura(48);
			}
		}

        protected static async Task<bool>  PostKeyPress(VirtualKeys key)
        {
            await PostKeyPress((int)key);
			
			return true;
        }

        protected static async Task<bool>  PostKeyPress(int key)
        {
            PostMessage(Core.Memory.Process.MainWindowHandle, WM_KEYDOWN, new IntPtr(key), IntPtr.Zero);
            PostMessage(Core.Memory.Process.MainWindowHandle, WM_KEYUP, new IntPtr(key), IntPtr.Zero);
			await Coroutine.Sleep(500);
			
			return true;
        }

		public static bool ContainsFoodItem(string foodName)
		{
			return InventoryManager
				.FilledSlots
				.Select(s => s.EnglishName)
				.Contains(foodName);
		}

		public static BagSlot GetFoodItem(string foodName)
		{
			return InventoryManager
				.FilledSlots
				.First(s => s.EnglishName == foodName);
		}
		
		public BagSlot GetCordial
		{
			get
			{
				if (FishTag.ContainsFoodItem("Hi-Cordial"))
				{
					return FishTag.GetFoodItem("Hi-Cordial");
				}
				
				if (FishTag.ContainsFoodItem("Cordial"))
				{
					return FishTag.GetFoodItem("Cordial");
				}
				
				return null;
			}
		}
		
		public BagSlot GetFood
		{
			get
			{
				if (!string.IsNullOrEmpty(Food) && FishTag.ContainsFoodItem(Food))
				{
					return FishTag.GetFoodItem(Food);
				}
				
				return null;
			}
		}
		
		public bool CanUseCordial
		{
			get
			{
				if (UseCordial && 
					!HasPatience && 
					!HasChum &&
					!HasSnagging &&
					Core.Me.CurrentGPPercent <= UseCordialMinGPPercent)
				{
					cordialItem = GetCordial;
						
					if (cordialItem != null)
					{
						return true;
					}
				}
				
				return false;
			}
		}
		
		public bool CanUseFood
		{
			get
			{
				if (!HasFood &&
					!HasPatience && 
					!HasChum &&
					!HasSnagging)
				{
					foodItem = GetFood;
						
					if (foodItem != null)
					{
						return true;
					}
				}

				return false;
			}
		}
		
        private bool HasSpecifiedBait
        {
            get
            {
                return
                    InventoryManager.FilledSlots.Any(
                        i => string.Equals(i.Name, this.Bait, StringComparison.InvariantCultureIgnoreCase));
            }
        }

        private bool IsBaitWindowOpen
        {
            get
            {
                return RaptureAtkUnitManager.Controls.Any(c => c.Name == "Bait" && c.IsValid);
            }
        }

        private bool IsBaitSpecified
        {
            get
            {
                return !string.IsNullOrEmpty(this.Bait);
            }
        }

        private bool IsCorrectBaitSelected
        {
            get
            {
				if (string.IsNullOrEmpty(currentBait))
				{
					return false;
				}
				
                return string.Equals(currentBait, this.Bait, StringComparison.InvariantCultureIgnoreCase);
            }
        }
		
        protected bool CanDoAbility(Abilities ability)
        {
            return Actionmanager.CanCast((uint)ability, Core.Player);
        }

        protected bool DoAbility(Abilities ability)
        {
            return Actionmanager.DoAction((uint)ability, Core.Player);
        }

 
        protected virtual bool ConditionCheck()
        {
            var conditional = ScriptManager.GetCondition(Condition);

            return conditional();
        }

        protected virtual bool MoochConditionCheck()
        {
            var moochConditional = ScriptManager.GetCondition(MoochCondition);

            return moochConditional();
        }

        protected virtual void Cast()
        {
            this.isFishIdentified = false;
            this.checkRelease = true;
            FishingManager.Cast();
            this.ResetMooch();
        }

        protected virtual void FaceFishSpot()
        {
            var i = MathEx.Random(0, 25);
            i = i / 100;

            var i2 = MathEx.Random(0, 100);

            if (i2 > 50)
            {
                Core.Player.SetFacing(FishSpots.Current.Heading - (float)i);
            }
            else
            {
                Core.Player.SetFacing(FishSpots.Current.Heading + (float)i);
            }
        }

        protected virtual void ChangeFishSpot()
        {
            FishSpots.Next();
            Log("Changing FishSpots...");
            fishcount = 0;
            Log("Resetting fish count...");
            fishlimit = this.GetFishLimit();
            spotinit = false;
            isSitting = false;
        }

        protected virtual int GetBaitCount()
        {
            var result =
                InventoryManager.FilledSlots.Where(
                    bs => bs.Item.Affinity == 19 && bs.Item.RequiredLevel <= Core.Player.ClassLevel)
                    .GroupBy(
                        bs => bs.RawItemId,
                        (key, groupedItems) => new { ItemId = key, Count = groupedItems.Sum(gi => gi.Count) })
                    .ToArray();

            return result.Length;
        }

        protected virtual int GetFishLimit()
        {
            return Convert.ToInt32(MathEx.Random(this.MinimumFishPerSpot, this.MaximumFishPerSpot));
        }

        protected void ShuffleFishSpots()
        {
            if (Shuffle && FishSpots.Index == 0)
            {
                FishSpots.Shuffle();
                Log("Shuffled fish spots");
            }
        }

        protected void ResetMooch()
        {
            if (mooch != 0)
            {
                mooch = 0;
                Log("Resetting mooch level.");
            }
        }

        protected string GetCurrentBait(string message)
        {
            if (BaitRegex.IsMatch(message))
            {
                var match = BaitRegex.Match(message);

                return match.Groups[1].Value;
            }

            return "Parse Error";
        }

        protected void SetFishResult(string message)
        {
            fishResult = new FishResult();

            var match = FishRegex.Match(message);

            if (match.Success)
            {
                fishResult.Name = match.Groups[1].Value;
                float size;
                float.TryParse(match.Groups[2].Value, out size);
                fishResult.Size = size;

                if (fishResult.Name[fishResult.Name.Length - 2] == ' ')
                {
                    fishResult.IsHighQuality = true;
                }
            }

            this.isFishIdentified = true;
        }

        protected void Log(string message, Color color)
        {
            Logging.Write(color, string.Format("[Fish v{0}] {1}", this.Version, message));
        }

        protected void Log(string message)
        {
            Log(message, Colors.Gold);
        }
		
        protected void ReceiveMessage(object sender, ChatEventArgs e)
        {
            if (e.ChatLogEntry.MessageType == MessageType.SystemMessages
                && e.ChatLogEntry.Contents.StartsWith("You apply"))
            {
                currentBait = GetCurrentBait(e.ChatLogEntry.Contents);
				baitApplied = true;
                Log("Applied Bait -> " + currentBait);
            }

            if (e.ChatLogEntry.MessageType == (MessageType)2115 && e.ChatLogEntry.Contents.StartsWith("You land"))
            {
                SetFishResult(e.ChatLogEntry.Contents);
            }

            if (e.ChatLogEntry.MessageType == (MessageType)2115
                && e.ChatLogEntry.Contents.Equals(
                    "You do not sense any fish here.",
                    StringComparison.InvariantCultureIgnoreCase))
            {
                Log("You do not sense any fish here, trying next location.");

                ChangeFishSpot();
            }

            if (e.ChatLogEntry.MessageType == (MessageType)2115
                && e.ChatLogEntry.Contents
                == "The fish sense something amiss. Perhaps it is time to try another location.")
            {
                Log("The fish sense something amiss!");
                amissfish++;

                ChangeFishSpot();
            }
        }
		
		public void Initialize()
		{
            FishSpots.IsCyclic = true;
            isSitting = false;
   			baitAttempts = 0;
			awaitBaitApplied = false;
			timedOutOnFirstBaitApplied = false;
			currentBait = null;
            isDone = false;
            spotinit = false;
            fishcount = 0;
			closeBait = false;
            fishlimit = GetFishLimit();
            baitCount = GetBaitCount();
			initializeFishing = true;
			isMoving = false;
		}
		
		public override bool IsDone
        {
            get
            {
                return this.isDone;
            }
        }
		
		protected override void OnStart()
        {
            if (this.Keepers == null)
            {
                this.Keepers = new List<Keeper>();
            }
			else
			{
				this.Keepers.Clear();
			}

            if (this.Collectables == null)
            {
                this.Collectables = new List<Collectable>();
            }
			else
			{
				this.Collectables.Clear();
			}

            GamelogManager.MessageRecevied += ReceiveMessage;
			
			Initialize();
			
			ShuffleFishSpots();

            cleanup = 
				(BotBase bot) =>
                {
					try
					{
						GamelogManager.MessageRecevied -= this.ReceiveMessage;
					}
					catch (Exception ex)
					{
						Log(ex.Message);
					}
					
					TreeRoot.OnStop -= cleanup;
                };

            TreeRoot.OnStop += cleanup;
        }

        protected override void OnDone()
        {
            cleanup(
				null);
        }

        protected override void OnResetCachedDone()
        {			
			Initialize();
        }

		public async Task<bool> AcceptOrRejectCollectable() 
		{
			await Coroutine.Sleep(2000);
			
			if (InventoryManager.FilledSlots.Count(c => c.BagId != InventoryBagId.KeyItems) > 98)
			{
				Log("Declining Collectible - Only 1 inventory space available", Colors.Red);
				
				SelectYesNoItem.No();
				
				return true;
			}

			uint value = 0;

			value = SelectYesNoItem.CollectabilityValue;

			if (value < 10)
			{
				await Coroutine.Sleep(3000);
			}

			value = SelectYesNoItem.CollectabilityValue;
			
			Log(
				string.Format(
					"Collectible caught with value: {0} required: {1}",
					value.ToString(),
					CollectabilityValue));
					
			if (value >= CollectabilityValue || value < 10)
			{
				Log("Collecting Collectible -> Value: " + value, Colors.Green);
				
				SelectYesNoItem.Yes();
			}
			else
			{
				Log("Declining Collectible -> Value: " + value, Colors.Red);
				
				SelectYesNoItem.No();
			}
			
			await Coroutine.Sleep(2000);
			
			return true;
		}
			
		public async Task<bool> ForceToIdleState()
		{
			CommonBehaviors.MoveStop();		
			
			if (FishingManager.State != FishingState.None)
			{
				if (Collect && SelectYesNoItem.IsOpen)
				{
					await AcceptOrRejectCollectable();					
				}
				
				await Coroutine.Wait(
					30000,
					() => CanDoAbility(Abilities.Quit));
					
				DoAbility(Abilities.Quit);
				
				await Coroutine.Wait(
					5000,
					() => FishingManager.State == FishingState.None);
					
				if (FishingManager.State != FishingState.None)
				{
					Log("Unable to force fishing to quit - State: "+FishingManager.State);
				}
			}
			
			return true;
		}
		
		protected Composite WaitUntilIdleComposite
		{
			get
			{
				return
					new ActionRunCoroutine(
						r => ForceToIdleState());
			}
		}

        protected Composite IsDoneAction
        {
            get
            {
              return
				new Sequence(
					WaitUntilIdleComposite,
					new Action(
						r =>
						{
							isDone = true;
						}));
           }
        }
		
        protected override Composite CreateBehavior()
        {
			return
				new Decorator(
					ret => !IsDone,
					new PrioritySelector(
						InitializeFishingComposite,
						//LogStateComposite,
						Conditional,
						Blacklist,
						MoveToFishSpot,
						DismountComposite,
						CheckStealthComposite,
						CheckWeatherComposite,
						// Waits up to 10 hours, might want to rethink this one.
						EnsureBait,
						OpenBait,
						CloseBait,
						ApplyBait,
						InitFishSpotComposite,
						StateTransitionAlwaysSucceedComposite,
						CollectablesComposite,
						ReleaseComposite,
						MoochComposite,
						FishCountLimitComposite,
						InventoryFullComposite,
						SitComposite,
						CollectorsGloveComposite,
						FoodComposite,
						CordialComposite,
						SnaggingComposite,
						PatienceComposite,
						ChumComposite,
						CastComposite,
						HookComposite));
		}
		
		protected Composite InitializeFishingComposite
		{
			get
			{
				return
					new Decorator(
						ret => initializeFishing,
						new Sequence(
							WaitUntilIdleComposite,
							new Action(
								r =>
								{
									initializeFishing = false;
								})));
			}
		}
		
  		protected Composite LogStateComposite
		{
			get
			{
				return
					new Sequence(
							new Action(
									r =>
									{
										Log("State: "+FishingManager.State+
										    ", Window: "+SelectYesNoItem.IsOpen+
											", Quit: "+CanDoAbility(Abilities.Quit));
									}),
							new ActionAlwaysFail());
							
			}
		}

       protected Composite Conditional
        {
            get
            {
                return 
					new Decorator(
							ret => !ConditionCheck(), 
							IsDoneAction);
            }
        }

        protected Composite Blacklist
        {
            get
            {
                return 
					new Decorator(
						ret => amissfish > Math.Min(FishSpots.Count, 4),
						new Sequence(
							new Action(
								r =>
									{
										Log("The fish are amiss at all of the FishSpots.");
										Log(
											"This zone has been blacklisted, please fish somewhere else and then restart the profile.");
									}),
							IsDoneAction));
            }
		}
	   
		protected Composite MoveToFishSpot
        {
            get
			{
				return
					new PrioritySelector(
						new Decorator(
							ret => 
								Vector3.Distance(Core.Player.Location, FishSpots.CurrentOrDefault.XYZ) > 1.0,
							new Sequence(
								WaitUntilIdleComposite,
								CommonBehaviors.MoveAndStop(
									ret => FishSpots.CurrentOrDefault.XYZ,
									0.6f,
									true,
									"Fish Spot"),
								new Action(
									r =>
									{
										isMoving = true;
									}))),
						new Decorator(
							ret => isMoving,
							new Sequence(
								CommonBehaviors.MoveStop(),
								new Action(
									r =>
									{
										isMoving = false;
									}))));
			}
		}

        protected Composite DismountComposite
        {
            get
            {
                return 
					new Decorator(
						ret => Core.Player.IsMounted, 
						CommonBehaviors.Dismount());
            }
        }
		
		protected Composite CheckStealthComposite
        {
            get
            {
                return 
					new Decorator(
						ret => this.Stealth && !Core.Player.HasAura(47),
						new Sequence(
							new Action(
								r =>
									{
										CharacterSettings.Instance.UseMount = false;
										DoAbility(Abilities.Stealth);
									}),
							new Sleep(2, 3)));
            }
        }
		
        protected Composite CheckWeatherComposite
        {
            get
            {
                return 
					new Decorator(
						ret => Weather != null && Weather != WorldManager.CurrentWeather,
						new Sequence(
							new Action(r => { Log("Waiting for the proper weather..."); }),
							new Wait(36000, ret => Weather == WorldManager.CurrentWeather, new ActionAlwaysSucceed())));
            }
        }

        protected Composite InitFishSpotComposite
        {
            get
            {
                return 
					new Decorator(
						ret => !spotinit,
						new Action(
							r =>
								{
									FaceFishSpot();
									Log("Will fish for " + fishlimit + " fish before moving again.");
									spotinit = true;
								}));
            }
        }

        protected Composite StateTransitionAlwaysSucceedComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        FishingManager.State == FishingState.Reelin || FishingManager.State == FishingState.Quit
                        || FishingManager.State == FishingState.PullPoleIn,
                        new ActionAlwaysSucceed());
            }
        }

        protected Composite CollectablesComposite
        {
            get
            {
                return 
					new Decorator(
						ret => Collect && SelectYesNoItem.IsOpen,
						new ActionRunCoroutine(
							r => AcceptOrRejectCollectable()));
			}
        }
		
        protected Composite EnsureBait
        {
            get
            {
                return 
					new Decorator(
						ret => IsBaitSpecified && !HasSpecifiedBait,
						new Sequence(
							new Action(r => { Log("You do not have the specified bait: " + this.Bait); }),
							IsDoneAction));
            }
        }

        protected Composite OpenBait
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        IsBaitSpecified && !IsBaitWindowOpen && !IsCorrectBaitSelected && CanDoAbility(Abilities.Bait),
                        new Sequence(
                            new Action(r => { DoAbility(Abilities.Bait); }),
                            new WaitContinue(3, ret => IsBaitWindowOpen, new ActionAlwaysSucceed())));
            }
        }

        protected Composite CloseBait
        {
            get
            {
                return
                    new Decorator(
                        ret =>
							closeBait && CanDoAbility(Abilities.Bait),
							new Sequence(
								new Action(
									r => 
										{ 
											DoAbility(Abilities.Bait);
											closeBait = false;
										}),
								new WaitContinue(
									5, 
									ret => !IsBaitWindowOpen, 
									new ActionAlwaysSucceed())));
            }
        }
		
        protected Composite ApplyBait
        {
            get
            {
                return 
					new Decorator(
						ret => IsBaitSpecified && IsBaitWindowOpen,
						new PrioritySelector(
							new Decorator(
								ret => baitCount < 0,
								new Sequence(
									new Action(
										r => 
										{ 
											Log("Unable to find specified bait -> " + this.Bait + " in your inventory, ending profile");
										}),
									IsDoneAction)),
							new Decorator(
								ret => baitAttempts == 0,
								new ActionRunCoroutine(
									async(r) =>
									{
										Log("Selecting first bait in Bait window");
										currentBait = null;
										closeBait = false;
										baitAttempts = 1;
										baitApplied = false;
										awaitBaitApplied = true;
										timedOutOnFirstBaitApplied=false;
										await PostKeyPress(
											this.ConfirmKey);
										await PostKeyPress(
											this.ConfirmKey);
									})),
							new Decorator(
								ret => awaitBaitApplied,
								new Sequence(
									new Action(
										r =>
										{
											Log("Waiting for bait to be applied");
										}),
									new WaitContinue(
										3,
										ret => baitApplied,
										new ActionAlwaysSucceed()),
									new Action(
										r =>
										{
											if (!baitApplied)
											{
												if (baitAttempts == 1)
												{
													timedOutOnFirstBaitApplied = true;
												}
												
												Log("Timed out waiting for bait to be applied (probably because it is already selected)");
											}
											
											awaitBaitApplied = false;
										}))),
							new PrioritySelector(
								new Decorator(
									ret => !IsCorrectBaitSelected,
									new PrioritySelector(
										new Decorator(
											ret => string.IsNullOrEmpty(currentBait) && baitCount == 1,
											new Action(
												r =>
												{
													Log("You only have one bait and it appears it is already selected; no way to determine if it is a "+this.Bait+", so assuming it is.");
													currentBait = this.Bait;
												})),
										new Decorator(
											ret => (timedOutOnFirstBaitApplied && baitAttempts >= baitCount+1) || (!timedOutOnFirstBaitApplied && baitAttempts >= baitCount),
											new Sequence(
												new Action(
													r => 
													{
														Log("Unable to select specified bait -> " + this.Bait + ", ending profile");
													}),
												IsDoneAction)),
										new ActionRunCoroutine(
											async(r) =>
											{
												Log("Selecting next bait in Bait window");
												baitAttempts++;
												baitApplied = false;
												awaitBaitApplied = true;
												await PostKeyPress(this.MoveCursorRightKey);
												await PostKeyPress(this.ConfirmKey);
											}))),
							new Action(
									r => 
									{
										Log("Bait Selected -> " + this.Bait); 
										baitAttempts = 0;
										closeBait = true;
									}))));
			}
        }

        protected Composite ReleaseComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        this.checkRelease && FishingManager.State == FishingState.PoleReady
                        && CanDoAbility(Abilities.Release) && this.Keepers.Count != 0,
                        new Sequence(
                            new WaitContinue(
                                2,
                                ret => this.isFishIdentified,
                                new Action(
                                    r =>
                                        {
                                            // If its not a keeper AND we aren't mooching or we can't mooch, then release
                                            if (!this.Keepers.Any(fishResult.IsKeeper)
                                                && (MoochLevel == 0 || !CanDoAbility(Abilities.Mooch)))
                                            {
                                                DoAbility(Abilities.Release);
                                                Log("Released " + fishResult.FishName);
                                            }

                                            this.checkRelease = false;
                                        })),
                            new WaitContinue(2, ret => !CanDoAbility(Abilities.Release), new ActionAlwaysSucceed())));
            }
        }
		
        protected Composite MoochComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        CanDoAbility(Abilities.Mooch) && MoochLevel != 0 && mooch < MoochLevel && MoochConditionCheck() &&
                        (this.Keepers.Count == 0 || this.Keepers.Any(k => string.Equals(k.Name, fishResult.FishName, StringComparison.InvariantCultureIgnoreCase) && fishResult.ShouldMooch(k))),
                        new Sequence(
                            new Action(
                                r =>
                                    {
                                        // TODO: check keepers for mooch
                                        FishingManager.Mooch();
                                        mooch++;
                                        if (MoochLevel > 1)
                                        {
                                            Log("Mooching, this is mooch " + mooch + " of " + MoochLevel + " mooches.");
                                        }
                                        else
                                        {
                                            Log("Mooching, this will be the only mooch.");
                                        }
                                    }),
                            new Sleep(2, 2)));
            }
        }
		
		protected Composite FishCountLimitComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        fishcount >= fishlimit && !HasPatience,
                        new Sequence(
							WaitUntilIdleComposite,
                            new Action(
								r => 
								{ 
									ChangeFishSpot(); 
								})));
            }
        }

        protected Composite InventoryFullComposite
        {
            get
            {
                return
                    new Decorator(
                        ret => InventoryManager.FilledSlots.Count(c => c.BagId != InventoryBagId.KeyItems) >= 100,
                        IsDoneAction);
            }
        }
		
        protected Composite SitComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        !isSitting && (Sit || FishSpots.CurrentOrDefault.Sit) && FishingManager.State == (FishingState)9,
                        // this is when you have already cast and are waiting for a bite.
                        new Sequence(
                            new Sleep(1, 1),
                            new Action(
                                r =>
                                    {
                                        isSitting = true;
                                        Log("Sitting " + FishSpots.CurrentOrDefault);
                                        ChatManager.SendChat("/sit");
                                    })));
            }
        }

        protected Composite CollectorsGloveComposite
        {
            get
            {
                return 
					new Decorator(
						ret => CanDoAbility(Abilities.CollectorsGlove) && ((Collect && !HasCollectorsGlove) || (!Collect && HasCollectorsGlove)),
						new Sequence(
							new Action(
								r =>
									{
										Log("Casting Collector's Glove");
										DoAbility(Abilities.CollectorsGlove);
									}),
							new Sleep(2, 3)));
            }
        }

		protected Composite FoodComposite
		{
			get
			{
				return
					new Decorator(
						ret => CanUseFood,
						new Sequence(
							WaitUntilIdleComposite,
							new Action(
								r =>
								{
									Log("Using "+foodItem.Name);
									foodItem.UseItem();
								}),
							new WaitContinue(
								3,
								ret => HasFood,
								new ActionAlwaysSucceed())));
			}
		}
		
 		protected Composite CordialComposite
		{
			get
			{
				return
					new Decorator(
						ret => CanUseCordial,
						new Sequence(
							WaitUntilIdleComposite,
							new Action(
								r =>
								{
									Log("Using "+cordialItem.Name);
									cordialItem.UseItem();
								}),
							new Sleep(2000)));
			}
		}

        protected Composite SnaggingComposite
        {
            get
            {
                return 
					new Decorator(
						ret => CanDoAbility(Abilities.Snagging) && Snagging && !HasSnagging,
						new Sequence(
							new Action(
								r =>
									{
										Log("Toggle Snagging");
										DoAbility(Abilities.Snagging);
									}),
							new Sleep(2, 3)));
            }
        }

        protected Composite PatienceComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        Patience > Abilities.None
                        && Core.Player.CurrentGP == Core.Player.MaxGP
						&& (FishingManager.State == FishingState.None || FishingManager.State == FishingState.PoleReady)
                        && !HasPatience && CanDoAbility(Patience),
                        new Sequence(
                            new Action(
                                r =>
                                    {
                                        DoAbility(Patience);
                                        Log(Patience+" activated");
                                    }),
                            new WaitContinue(
								3,
								ret => HasPatience,
								new ActionAlwaysSucceed())));
            }
        }
		
		protected Composite ChumComposite
        {
            get
            {
                return 
					new Decorator(
						ret => Chum && !HasChum && CanDoAbility(Abilities.Chum),
						new Sequence(
							new Action(
								r => DoAbility(Abilities.Chum)), 
							new Sleep(1, 2)));
            }
        }

        protected Composite CastComposite
        {
            get
            {
                return
                    new Decorator(
                        ret =>
                        FishingManager.State == FishingState.None || FishingManager.State == FishingState.PoleReady,
						new Action(
							r => this.Cast()));
				}
        }

        protected Composite HookComposite
        {
            get
            {
                return 
					new Decorator(
						ret => FishingManager.CanHook && FishingManager.State == FishingState.Bite,
						new Action(
							r =>
								{
									if (HasPatience && CanDoAbility(Hookset))
									{
										DoAbility(Hookset);
										Log("Using (" + Hookset + ")");
									}
									else
									{
										FishingManager.Hook();
									}

									amissfish = 0;
									if (mooch == 0)
									{
										fishcount++;
									}

									Log("Fished " + fishcount + " of " + fishlimit + " fish at this FishSpot.");
								}));
            }
        }
    }
}